(* Code copyright 2003 Alan Post
 *
 * This file is part of mineml.
 *
 * mineml is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mineml is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with mineml; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *************************************************
 *
 * Images copyright 1993-1999 Marc Baudoin,
 *   available in the 'xdemineur' program under the following license:
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  The author makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 *)


let arr = ref [||]
let point = ref None

let init window =
    point := Some (GDraw.pixmap_from_xpm_d ~window ~data:
[|
"10 30 2 1";
"- c red m white";
"# c black";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"##########";
"###----###";
"###----###";
"###----###";
"###----###";
"##########";
"##########";
|] ());

    arr := Array.map (fun data -> GDraw.pixmap_from_xpm_d ~window ~data ()) [|
[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"##-#------------#-##";
"##--#----------#--##";
"##---#--------#---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---##########---##";
"##--############--##";
"##-##############-##";
"####################";
"##-##############-##";
"##--############--##";
"##---##########---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---#--------#---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"####################";
"#################-##";
"################--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"################--##";
"#################-##";
"####################";
"#################-##";
"################--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"################--##";
"#################-##";
"####################";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"######--------#---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"#####----------#--##";
"####------------#-##";
"###--------------###";
"##-#------------####";
"##--#----------#####";
"##---###############";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##---#--------######";
"##--#----------#####";
"##-#------------####";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"######--------#---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"#####----------#--##";
"####------------#-##";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"######--------#---##";
"#####----------#--##";
"####------------#-##";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"####################";
"##-##############-##";
"##--############--##";
"##---##########---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---##########---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"################--##";
"#################-##";
"####################";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"##-#------------####";
"##--#----------#####";
"##---#--------######";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##---###############";
"##--#----------#####";
"##-#------------####";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"######--------#---##";
"#####----------#--##";
"####------------#-##";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"##-#------------####";
"##--#----------#####";
"##---#--------######";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##----##############";
"##---###############";
"##--#----------#####";
"##-#------------####";
"###--------------###";
"##-#------------#-##";
"##--#----------#--##";
"##---##########---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---#--------#---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"######--------#---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"################--##";
"#################-##";
"####################";
"#################-##";
"################--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"###############---##";
"################--##";
"#################-##";
"####################";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"##-#------------#-##";
"##--#----------#--##";
"##---#--------#---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---##########---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"##-#------------#-##";
"##--#----------#--##";
"##---##########---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---#--------#---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"####################";
"####################";
|];

[|
"20 30 2 1";
"- c red m white";
"# c black";
"####################";
"####################";
"###--------------###";
"##-#------------#-##";
"##--#----------#--##";
"##---#--------#---##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##----########----##";
"##---##########---##";
"##--#----------#--##";
"##-#------------#-##";
"###--------------###";
"####------------#-##";
"#####----------#--##";
"###############---##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"##############----##";
"######--------#---##";
"#####----------#--##";
"####------------#-##";
"###--------------###";
"####################";
"####################";
|];
|]

let get i = (!arr).(i)
let get_decimal_point () = match !point with
      None -> raise Not_found
    | Some x -> x

