(* Copyright 2003 Alan Post
 *
 * This file is part of mineml.
 *
 * mineml is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mineml is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with mineml; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

type t = { arr: GMisc.image array;
           mutable value: int }

let make ~packing ~digits =
    let box = GPack.hbox ~packing () in
    { value = 0;
      arr = Array.init digits (fun _ -> GMisc.image ~packing:box#pack
        ~pixmap:(DigitPixmaps.get 0)#pixmap ())}

let value this = this.value

let set this n =
    if n <> this.value then begin
        this.value <- n;
        let len = Array.length this.arr in
        let rec f cur i =
            if i < len then begin
                this.arr.(len - i - 1)#set_pixmap
                    (DigitPixmaps.get (cur mod 10));
                f (cur/10) (i+1)
            end
        in
        f n 0
    end
